#include "../main.h"
#include <cmath>	// muss vor "plotxy.h" sein sonst gibt's rger mit <intrin.h>
#include "cplotxy.h"
#include "../util/noexcept.h"

/**********
 * PlotXY *
 **********/
//Pen PlotXY::nullpen;	// gibt's nicht als StockObject
PlotXY::SystemSettings PlotXY::systemsettings;

void PlotXY::SystemSettings::readFromSystem() {
 GetProfileString(TEXT("Intl"),TEXT("sDecimal"),TEXT("."),sDecimal,elemof(sDecimal));
 GetProfileString(TEXT("Intl"),TEXT("sTime"),TEXT(":"),sTime,elemof(sTime));
 iMeasure=!!GetProfileInt(TEXT("Intl"),TEXT("iMeasure"),0);
}

Axis&PlotXY::insertAxis(AXISATTR&a) {
// Nur das Anhngen einer Zeile unten oder Spalte rechts ist erlaubt,
// wenn der Zeilen/Spaltenindex genau am Ende steht.
// Das Einfgen von Zeilen/Spalten ist erst mal nicht vorgesehen,
// dazu msste man ber alle vorhandenen Achsen iterieren,
// die wiederum ber ihre Plots iterieren, um deren column/row-Daten anzupassen.
  char plotspan = span_in_plots(a.side&1);
  if (a.iplotxy == plotspan
  || a.side&1<<Axis::bSeparate		// Diese Achse soll einen Plotbereich generieren
  || axisAttrOfColRow(a.side&1,a.iplotxy)&1<<Axis::bSeparate) {
    span_in_plots_inc(a.side&1,!!(a.side&0x10));	// wenn feste Hhe gewnscht wird der Wunsch erfllt
    a.iplotxy = plotspan++;	// hintenan
  }
  if ((unsigned)a.iplotxy >= (unsigned)plotspan) a.iplotxy=0;	// Ungltiger Index wird Null!
//  a.iaxis = axes.size();	// Nummer rckmelden
  Axis*axis = a.side&1?(Axis*)new YAxis(*this,a):new XAxis(*this,a);
  axis->iaxis = char(axes.size());	// Nummer setzen
// Achtung! Hier ist <a> der Zeiger beraubt!
  axes.push_back(axis);		// geht ber ein temporres, dann raubkopiertes uniq_ptr<Axis>-Objekt
  dirty|=1<<bArrangeAll;	// weil kein C++11 oder Spezialisierung von vector<T> auf vector<uniq_ptr<T>>
  return *axis;
}

Axis&PlotXY::assignAxis(AXISATTR&a) {
// Einen Kandidaten mit passender Seite finden
  if (a.side&0x01 && a.side&0x10) return insertAxis(a);		// Digital: immer neu
// "visible" spielt hier keine Rolle
  for (axes_t::iterator ia=axes.begin(); ia!=axes.end(); ia++) {
    Axis&ax=**ia;
    if (ax==a) {
//      a=AXISATTR(ax);	// rckmelden: Geht nicht, das raubt ax die String-Zeiger! Besser mit string-Objekt!
      return ax;	// Achse gefunden, keine neue Achse erzeugen
    }
  }
  return insertAxis(a);	// Neue Achse, ggf. neuer Plotbereich
}

Axis&PlotXY::assignAxis(Trace&tr, DWORD side) {
 AXISATTR a;
 a.side=side;
 a.iaxis  =tr.ixyaxis[side&1];
 a.iplotxy=tr.iplotxy[side&1];
 if (tr.xydata[side&1]) {
  a.name=const_cast<TCHAR*>(tr.xydata[side&1]->name());	// BUG: const TCHAR kann nicht deleted werden!
  a.unit=const_cast<TCHAR*>(tr.xydata[side&1]->unit());
  a.precis=tr.xydata[side&1]->precis();
 }
 size_t siz=axes.size();
 Axis&ax=assignAxis(a);		// Achse finden oder (nicht nochmal!!) neu generieren
 if (axes.size()!=siz) DEBUG(("Doppelte Achsen derzeit unerwnscht! Index %u",unsigned(siz)));
 ax.traces.push_back(&tr);	// Der gefundenen Achse diesen Trace zuordnen (zur Autoskalierung und ggf. Farbgebung)
 ax.side|=Axis::INVAL_RANGE|Axis::INVAL_TICKS;	// TODO: Invalidierung im Achsen-Kode
 tr.iplotxy[side&1]=ax.iplotxy;	// Indizes festlegen
 tr.ixyaxis[side&1]=ax.iaxis;
// BUG: Hier wird extents_xy[1].extents[4] zerstrt!!
 return ax;
}

DWORD PlotXY::axisAttrOfColRow(unsigned xysel,char cr) {
  if (cr<0) cr=0;
  else{
   char plotspan = span_in_plots(xysel);
   if (cr>=plotspan) cr=plotspan-1;
  }
  for (axes_t::iterator ia=axes.begin(); ia!=axes.end(); ia++) {
    Axis&ax=**ia;
    if (!((ax.side^xysel)&1) && ax.iplotxy==cr) return ax.side;
  }
  return xysel;
}

void PlotXY::span_in_plots_inc(unsigned xysel,bool fixed) {
 ExtentList::Extents&E=extents_xy[xysel].extents;
 if (!E.size()) E.push_back(new ExtentFix());
 E.push_back(fixed ? new ExtentFix(16) : new ExtentVar(xysel?50:100));	// Minimalbreite grer Minimalhhe
 E.push_back(new ExtentFix());
}

int PlotXY::textWidth(const TCHAR*s,int l) const{
 HDC dc=getdc();
 SIZE sz;
 if (l<0) l=lstrlen(s);
 GetTextExtentPoint32(dc,s,l,&sz);
 releasedc();
 return sz.cx;
}

Metric PlotXY::textMetric() const {
 HDC dc=getdc();
 TEXTMETRIC tm;
 GetTextMetrics(dc,&tm);
 releasedc();
 return tm;	// auto-extracts the four important values out of tm
}

BOOL PlotXY::init() {
 systemsettings.readFromSystem();
#ifdef _DEBUG
 GdiSetBatchLimit(1);
#endif
// Generiert eine neue Fensterklasse zum Zeichnen von 2D-Plots
 WNDCLASSEX wc;
 memset(&wc,0,sizeof wc);
 wc.cbSize=sizeof wc;
 wc.style=CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS|CS_PARENTDC;
 wc.cbWndExtra=sizeof(PlotXY*);
 wc.lpfnWndProc=wndproc;
 wc.lpszClassName=TEXT("PlotXY");
 return RegisterClassEx(&wc);
}

LRESULT CALLBACK PlotXY::wndproc(HWND wnd, UINT msg, WPARAM wParam, LPARAM lParam) {
  PlotXY*self=(PlotXY*)GetWindowLongPtr(wnd,0);
  if (!self) {
    self=new PlotXY(wnd);
    SetWindowLongPtr(wnd,0,(LPARAM)self);
  }
  LRESULT ret=self->wndproc(msg,wParam,lParam);
  if (msg==WM_NCDESTROY) delete self;
  return ret;
}

Trace*PlotXY::insertTrace(TRACEATTR&ta) {
// TODO: Wunschplotarea einschrnken
  if ((unsigned)ta.itrace>traces.size()) ta.itrace=char(traces.size());	// am Ende
  Trace*t=new Trace(*this,ta);
  traces.insert(ta.itrace,t);
  return t;
}

LRESULT PlotXY::wndproc(UINT msg, WPARAM wParam, LPARAM lParam) {
 switch (msg) {
  case XY_ADDTRACE: {
   TRACEATTR*ta = (TRACEATTR*)lParam;
   if (IsBadWritePtr(ta,sizeof*ta)) return -3;
   return insertTrace(*ta) ? 0 : -1;	// insertTrace may modify iTrace and other index-like info
  }

  case XY_GETTRACE: {
   TRACEATTR*ta = (TRACEATTR*)lParam;
   if (IsBadWritePtr(ta,sizeof*ta)) return -3;	// invalid pointer
   if (ta->itrace<0) ta->itrace+=char(traces.size());	// negative index counts from end
   if (BYTE(ta->itrace)>=traces.size()) return -2;// (still) invalid index
   *ta = *traces[ta->itrace].get();	// BUG! copy public part of object
   return 0;
  }

  case XY_SETTRACE: {		// Verndert v.a. das optische Aussehen des Grafen, aber auch den Callback
   TRACEATTR*ta = (TRACEATTR*)lParam;
   if (IsBadWritePtr(ta,sizeof*ta)) return -3;
   if (ta->itrace<0) ta->itrace+=char(traces.size());
   if (BYTE(ta->itrace)>=traces.size()) return -2;
   // TODO: change trace
   return -1;
  }

  case XY_DELTRACE: {
   INT_PTR itrace = (INT_PTR)wParam;
   if (itrace<0) itrace+=traces.size();
   if (size_t(itrace)>=traces.size()) return -2;
   return traces.erase(itrace) ? 0 : -1;	// kill trace and enqueue full rearrange.
  }			// Will neither kill plot areas nor axes but switch them to be invisible

// lParam = bit mask to trace (i.e. up to 32 or 64 depending on bitness of PlotXY.dll), 0 = all traces
  case XY_UPDATE: {
   LPARAM mask=1;
   for (traces_t::iterator it=traces.begin();it!=traces.end();it++,mask<<=1) {
    if (!lParam || lParam&mask) {
     it->get()->flags|=1<<Trace::bNeedCalcPolys	// Neuberechnung des Grafen bei WM_PAINT erzwingen
		      |3<<Trace::bNeedUpdateRange;
     invalidate(*it->get());			// enqueue WM_PAINT for plot area of this trace
    }
   }
#if 0
   MSG msg;
   while (PeekMessage(&msg,hPlot,WM_USER,XY_SET_DX,PM_REMOVE|PM_QS_POSTMESSAGE)) {
    DEBUG(("Angesammelte Message msg=%u,wParam=%u,lParam=%u",msg.message,msg.wParam,msg.lParam));
    if (msg.message==XY_SET_Y && !IsBadWritePointer((void*)msg.lParam,256*4)) {
     delete[] reinterpret_cast<float*>(lParam);	// Das ist NICHT der Grund warum kein WM_PAINT kommt!
    }
   }
#endif
   UpdateWindow(hPlot);		// scheint nichts zu bringen wenn die Warteschlange berluft
  }return 0;

/* deprecated */
    case XY_SET_Y: {
     int tracenumber = HIWORD(wParam),
         samplecount = LOWORD(wParam);
     if ((unsigned)tracenumber>=traces.size()) return -1;
     Trace&tr=*traces[tracenumber].get();
     if (tr.xydata[0]) {
      if (tr.xydata[0]->size()!=samplecount) {
       tr.xydata[0] = 0;
      }
     }
     if (!tr.xydata[0]) {
      struct XDATA:public DATA{
       int _size;
       Float d0,dt;
       virtual int size() const {return _size;}
       virtual Float get(int i) const {return d0+i*dt;}
       XDATA(int sz,Float _d0,Float _dt):_size(sz),d0(_d0),dt(_dt) {}
      };
      tr.xydata[0]=new XDATA(samplecount,0,1);
     }
     struct YDATA:public DATA{
      int _size;
      array_ptr<Float> data;
      virtual int size() const {return _size;}
      virtual Float get(int i) const {return data[i];}
      YDATA(int sz,Float*_data):_size(sz),data(_data) {}
     };
     if (tr.xydata[1]) {
      const YDATA&prev=*reinterpret_cast<const YDATA*>(tr.xydata[1].get());
      ASSERT(prev._size==samplecount);	// sollte sich nicht ndern!
      ASSERT(memcmp(prev.data.get(),(Float*)lParam,samplecount*sizeof(Float)));	// sollte sich ndern!
     }
     tr.xydata[1]=new YDATA(samplecount,(Float*)lParam);
//     tr.flags|=1<<Trace::bNeedCalcPolys;
//     dirty|=1<<bCheckAutorange;
     invalidate(tr);
    }return 0;
/* End of deprecation */

  case WM_SIZE: if (wParam!=SIZE_MINIMIZED) {
   onSize(GET_X_LPARAM(lParam),GET_Y_LPARAM(lParam),true);
  }break;

  case WM_GETMINMAXINFO: {	// Is dictated by GridLayout underlying object
   LRESULT ret=DefWindowProc(hPlot,msg,wParam,lParam);
   MINMAXINFO&mmi=*(MINMAXINFO*)lParam;
   mmi.ptMinTrackSize.x=extents_xy[0].getMin();
   mmi.ptMinTrackSize.y=extents_xy[1].getMin();
   mmi.ptMaxTrackSize.x=extents_xy[0].getMax();
   mmi.ptMaxTrackSize.y=extents_xy[1].getMax();
     // TODO: add border, if any, because WM_GETMINMAXINFO uses window, not client coordinates
   return ret;
  }

  case WM_PAINT: {
   PAINTSTRUCT ps;
   ASSERT(!n_getdc);	// getdc() calls must be balanced by releasedc() calls here.
   ASSERT(!dc);		// Also, the last releasedc() must have successfully called ::ReleaseDC()
			// So dc is now the context from WM_PAINT
   paint(BeginPaint(hPlot,&ps),reinterpret_cast<Rect<>*>(&ps.rcPaint));
   EndPaint(hPlot,&ps);
  }return 0;		// don't pass to DefWindowProc()

  case WM_PRINTCLIENT: {
   ASSERT(!n_getdc);
   ASSERT(!dc);		// same assertions as above
   paint((HDC)wParam);	// paint entire client rectangle
  }break;

  case WM_CREATE: {
   CREATESTRUCT&cs=*(CREATESTRUCT*)lParam;
   onSetText(cs.lpszName);	// pass creation text to axis+trace fabrication parser
   SetTimer(hPlot,42,100,0);	// run auto-shrink timer which will re-scale non-zoomed axes to fit to trace data
  }break;

  case WM_SETTEXT: onSetText((TCHAR*)lParam); break;	// another way to axis+trace fabrication

  case WM_WININICHANGE: {	// When system preferences are changed by user 
   SystemSettings backup=systemsettings;
   systemsettings.readFromSystem();
   if (systemsettings==backup) break;	// nothing relevant has been changed
   dirty|=1<<bArrangeAll;	// may change everything (BUG: Must be broadcast to all PlotXY windows!)
   invalidate();
  }break;

  case WM_TIMER: switch (wParam) {
   case 42: for (axes_t::iterator ia=axes.begin(); ia!=axes.end(); ia++) ia->get()->onTimer(100); break;
  }break; // For the one-and-only timer, loop over all axes
/*
    case WM_KEYDOWN:
    case WM_KEYUP: if (wParam==VK_CONTROL && mousetrack.tracking) {
      POINT pt;
      GetCursorPos(&pt);
      SendMessage(hPlot,WM_NCHITTEST,0,MAKELONG(pt.x,pt.y));
    }break;
*/
  case WM_SETCURSOR: if (LOWORD(lParam)==HTCLIENT) {
   SetCursor(hCursor);	// show cursor calculated by WM_NCHITTEST
   return TRUE;
  }break;

  case WM_NCHITTEST: {	// find right cursor shape for mouse position
   LRESULT r=DefWindowProc(hPlot,msg,wParam,lParam);
   if (r==HTCLIENT) {
    const TCHAR*curs;
    Point<>pt={GET_X_LPARAM(lParam),GET_Y_LPARAM(lParam)};
    ScreenToClient(hPlot,pt);	// mouse position
    gridpos_t gridpos=findArea(pt);
    if (gridpos.x&gridpos.y&1) {	// both odd: This is a plot area
     curs=IDC_ARROW;
     if (GetCapture()!=hPlot) {	// Bei MausCapture Tracking nicht nach Nhe beurteilen sondern behalten
      if (mousetrack.tracking) {
       invalidate(mousetrack.iplotx,mousetrack.iploty);
      }
      mousetrack.tracking=!!findTrace(pt);
     }
     if (mousetrack.tracking) {	// genauer untersuchen:
      invalidate(mousetrack.iplotx,mousetrack.iploty);
      Trace&tr=*traces[mousetrack.itrace];
// Mglichkeiten: Punkt oder Strecke markiert; Punkt: Verschieben oder Lschen; Strecke: Verschieben oder neuer Punkt
      bool onPoint=mousetrack.where<=0 || mousetrack.where>=1;
      bool canMoveX=false,canMoveY=false;
      if (onPoint) {
       int seg=mousetrack.segment;
       if (mousetrack.where>=1) ++seg;
       if (GetKeyState(VK_CONTROL)<0) {
        bool canErase=tr.xydata[0]->getCaps(seg)&DATA::can_erase
		   && tr.xydata[1]->getCaps(seg)&DATA::can_erase;
	if (canErase) curs=IDC_NO;	// TODO: Aussagekrftigerer Kursor (mit Minus)
       }else{
        if (tr.xydata[0]->getCaps(seg)&DATA::can_set) canMoveX=true;
        if (tr.xydata[1]->getCaps(seg)&DATA::can_set) canMoveY=true;
       }
      }else{
       int seg=mousetrack.segment;
       if (GetKeyState(VK_CONTROL)<0) {
        bool canInsert=tr.xydata[0]->getCaps(seg)&DATA::can_insert
		    && tr.xydata[1]->getCaps(seg)&DATA::can_insert;
	if (canInsert) curs=IDC_CROSS;	// TODO: Aussagekrftigerer Kursor (mit Plus)
       }else{
        if (tr.xydata[0]->getCaps(seg)&DATA::can_set
	 && tr.xydata[0]->getCaps(seg+1)&DATA::can_set) canMoveX=true;
        if (tr.xydata[1]->getCaps(seg)&DATA::can_set
	 && tr.xydata[1]->getCaps(seg+1)&DATA::can_set) canMoveY=true;
       }
      }
      if (canMoveX && canMoveY) curs=IDC_SIZEALL;
      else if (canMoveX) curs=IDC_SIZEWE;
      else if (canMoveY) curs=IDC_SIZENS;
     }
    }else curs=(findEditableLabel(gridpos,pt)) ? IDC_IBEAM : gridmovecursor(gridpos);
    hCursor = LoadCursor(0,curs);
    SetCursor(hCursor);	// doppelt gemoppelt!
   }
   return r;
  }
  
  case WM_RBUTTONDOWN: {
   Point<>pt={GET_X_LPARAM(lParam),GET_Y_LPARAM(lParam)};
   gridpos_t gridpos=findArea(pt);
   for (axes_t::iterator ai=axes.begin(); ai!=axes.end(); ai++) {
    Axis&ax=*ai->get();
    if (ax.cr==gridpos) {
     ax.onRButtonDown(pt);
     break;	// Nur eine!
    }
   }
  }break;

  case WM_KEYDOWN: switch ((BYTE)wParam) {
   case VK_LEFT: HandleHScroll(SB_LINELEFT); break;
   case VK_RIGHT: HandleHScroll(SB_LINERIGHT); break;
   case VK_UP: HandleVScroll(SB_LINELEFT); break;
   case VK_DOWN: HandleVScroll(SB_LINERIGHT); break;
   case VK_PRIOR: HandleVScroll(SB_PAGERIGHT); break;
   case VK_NEXT: HandleVScroll(SB_PAGELEFT); break;
   case VK_HOME: HandleHScroll(SB_PAGERIGHT); break;
   case VK_END: HandleHScroll(SB_PAGELEFT); break;
   case VK_TAB: HandleTab(0); break;
//   case VK_RETURN: SetHotTrace(HoverIndex); break;
  }break;

  case WM_CHAR: if (IsCharAlpha((TCHAR)wParam)) HandleTab((TCHAR)wParam);
  else switch ((int)wParam) {
   case '+': SetScale(SB_LINERIGHT); break;	// ACDSee-kompatibel
   case '-': SetScale(SB_LINELEFT); break;
   case '/': SetScale(100); break;		// 100 = Magic fr 100%
   case '*': SetScale(66); break;		// 66 = Magic fr "an Fenstergre anpassen"
  }break;

 }

 return DefWindowProc(hPlot,msg,wParam,lParam);
}

const TCHAR*PlotXY::gridmovecursor(gridpos_t gridpos) const{
// Horizontal schieben mglich wenn in gerader Gridspalte, nicht ganz links und nicht ganz rechts
 bool hresize = !(gridpos.x&1) && gridpos.x && gridpos.x!=gridsize(0)-1,
      vresize = !(gridpos.y&1) && gridpos.y && gridpos.y!=gridsize(1)-1;	// Dito vertikal
 char aresize = (char)vresize<<1|(char)hresize;		// Zwei Bits
 return aresize ? MAKEINTRESOURCE((UINT)IDC_SIZEWE-1+aresize) : IDC_ARROW;
}

HDC PlotXY::getdc() const{
 if (n_getdc && !dc) DEBUG(("wrong getdc/releasedc nesting"));
 else if (dc || (dc=GetDC(hPlot))) ++n_getdc; return dc;
}

void PlotXY::releasedc() const{
 if (!n_getdc || !dc) DEBUG(("wrong getdc/releasedc nesting"));
 else if (!--n_getdc && ReleaseDC(hPlot,dc)) dc=0;
}

// TODO: Miniaturen wie in jBEAM oder Funkuhr.exe
void PlotXY::paint(HDC dc,Rect<>*rcUpdate) {
 axes_t::iterator ia;
 for (ia=axes.begin(); ia!=axes.end(); ia++) ia->get()->checkAutorange();
 if (dirty) {
  if (_bittestandreset(&dirty,bCheckAutorange))
  if (_bittestandreset(&dirty,bCheckAxes))
  for (ia=axes.begin(); ia!=axes.end(); ia++) ia->get()->checkRange();
  if (_bittestandreset(&dirty,bArrangeAll)) arrange();	// arrange() kann Bits erneut setzen: Scheie!
 }
//  dirty=0;
 Point<char>i,e={span_in_plots(0),span_in_plots(1)};
 SaveDC(dc);
// Um Flackern der Plotbereiche zu vermeiden, diese aus der Zeichenflche herausnehmen
 for (i.y = 0; i.y<e.y; i.y++)
 for (i.x = 0; i.x<e.x; i.x++) {
  Rect<>rc(extent(icr(i.x),icr(i.y)));
  ExcludeClipRect(dc,rc.left,rc.top,rc.right,rc.bottom);
 }
// Hintergrund aller Achsen lschen
 if (rcUpdate) FillRect(dc,*rcUpdate,bBack);
 else{
  Rect<>rc(hPlot,true);	// ::GetClientRect()
  FillRect(dc,rc,bBack);
 }
 SetBkColor(dc,Color(250,250,250));	// Texte der Skalen damit ausgeben
 for (ia=axes.begin(); ia!=axes.end(); ia++) {
  Axis&ax=*ia->get();
// TODO: Dies woanders tun! Ist aber Kleinkram.
  ax.iaxis=char(ia-axes.begin());
  ax.cr.xy[ax.side&1  ]=icr(ax);
  ax.cr.xy[ax.side&1^1]=irc(ax);
  if (!ax.visible()) continue;
//  SaveDC(dc);
  Rect<>rc(extent(ax.col,ax.row));
  SetViewportOrgEx(dc,rc.left,rc.top,0);
  if (false) {	// Clipping fr Skalen sollte berflssig sein, aber man wei ja nie 
   Rectangle(dc,0,0,rc.width(),rc.height());	// Debug
   if (ax.side&1) {
    int ht=wh(ax,-1), hb=wh(ax,1);
    IntersectClipRect(dc,0,-ht,rc.width(),rc.height()+ht+hb);	// Zeichenbereich grer als Skale!
   }else{
    int wl=wh(ax,-1), wr=wh(ax,1);
    IntersectClipRect(dc,-wl,0,rc.width()+wl+wr,rc.height());	// Zeichenbereich grer als Skale!
   }
  }
  ax.paint(dc);
  SetViewportOrgEx(dc,0,0,0);
//  RestoreDC(dc,-1);
 }
 RestoreDC(dc,-1);
// Plotbereiche lschen (es sollte ja nichts heraus ragen!)
 for (i.y = 0; i.y<e.y; i.y++)
 for (i.x = 0; i.x<e.x; i.x++) {
  Rect<>rc(extent((i.x<<1)+1,(i.y<<1)+1));
  FillRect(dc,rc,bArea);
 }
// TODO: Jetzt Orientierungslinien einzeichnen
 for (i.y = 0; i.y<e.y; i.y++)
 for (i.x = 0; i.x<e.x; i.x++) {
  Rect<>rc(extent(icr(i.x),icr(i.y)));
  SaveDC(dc);
  SetViewportOrgEx(dc,rc.left,rc.top,0);
  if (false) {
   IntersectClipRect(dc,0,0,rc.width(),rc.height());
  }
// Plotflchen
  traces_t::const_iterator it;
// Kurvenzge aktualisieren
  for (it=traces.begin(); it!=traces.end(); it++) {
   Trace&tr=*it->get();
// TODO: Dies woanders tun! Ist aber Kleinkram.
   tr.iplotx=tr.xaxis.iplotxy;
   tr.iploty=tr.yaxis.iplotxy;
   tr.ixaxis=tr.xaxis.iaxis;
   tr.iyaxis=tr.yaxis.iaxis;
   tr.calcpolys();
  }
// Zuerst die gefllten Flchen
  for (it=traces.begin(); it!=traces.end(); it++) {
   Trace&tr=*it->get();
   if (tr.iplot!=i) continue;
   if (!tr.visible()) continue;
   if (tr.fill.size()) tr.paintPoly(dc);
  }
// Plotlinien darber
  for (it=traces.begin(); it!=traces.end(); it++) {
   Trace&tr=*it->get();
   if (tr.iplot!=i) continue;
   if (!tr.visible()) continue;
   if (tr.lines.size()) tr.paintLine(dc);
  }
// Plotmarker obenauf
  for (it=traces.begin(); it!=traces.end(); it++) {
   Trace&tr=*it->get();
   if (tr.iplot!=i) continue;
   if (!tr.visible()) continue;
   if (tr.marker) tr.paintMark(dc);
  }
  RestoreDC(dc,-1);
 }
 if (mousetrack.tracking) {
    Trace&tr=*traces[mousetrack.itrace];
    Float where=mousetrack.where;
    ensureMinMax(where,0.f,1.f);	// an Enden begrenzen
    Point<>*seg=&tr.lines[0]->operator[](mousetrack.segment);
    Point<> pt={seg[0].x+lrint((seg[1].x-seg[0].x)*where),
	        seg[0].y+lrint((seg[1].y-seg[0].y)*where)};
    SelectBrush(dc,GetStockBrush(HOLLOW_BRUSH));
    Ellipse(dc,pt.x-MOUSECAPTURE,pt.y-MOUSECAPTURE,pt.x+MOUSECAPTURE+1,pt.y+MOUSECAPTURE+1);
 }
// TODO: Cursor usw. einzeichnen
}

//#define USE_ALLOCA

void PlotXY::arrange() {
 flags&=~(1<<bArrangeAll);
// Achsen sichtbar/unsichtbar schalten: Unsichtbare Traces bekommen auch keine Achse!?
  axes_t::iterator ia;
  traces_t::iterator it;
/*
  for (ia=axes.begin(); ia!=axes.end(); ia++) {
    Axis&ax=**ia;
    ax.side&=~(1<<Axis::bVisible);
  }
  for (it=traces.begin(); it!=traces.end(); it++) {
    Trace&tr=**it;
    if (tr.visible()) {
      tr.xaxis.side|=1<<Axis::bVisible;
      tr.yaxis.side|=1<<Axis::bVisible;
    }
  }
*/
  char ex=gridsize(0),ey=gridsize(1);
#ifdef USE_ALLOCA
  int*needX=(int*)_alloca(ex*sizeof(int)); 
  int*needY=(int*)_alloca(ey*sizeof(int)); 
#else
  int*needX=new int[ex];
  int*needY=new int[ey];
#endif
  memset(needX,0,ex*sizeof(int));
  memset(needY,0,ey*sizeof(int));
// Achsen vermessen
  for (ia=axes.begin(); ia!=axes.end(); ia++) {
    Axis&ax=**ia;
    if (!ax.visible()) continue;
    Margin<>m;
    int *needXh=ax.side&1?needY:needX,	// needX array in case of horizontal (X) axis
	*needYh=ax.side&1?needX:needY;
    char cr=icr(ax);	// column or row
    toMax(needXh[cr],ax.needSpace(m));	// liefert Mindestbreite (X) / Mindesthhe (Y)
    toMax(needXh[cr-1],m.l);
    toMax(needXh[cr+1],m.r);
    toMax(needYh[irc(ax)],m.t);		// Rand der Achse
    toMax(needYh[irc(ax.side^1)],m.b);	// Gegenberliegender Rand
  }

#if 0	// wird nicht mehr gebraucht, passiert bei assignAxis!
// Anzahl vertikal gestapelter Achsen ermitteln und zuordnen (max. 32)
  struct YI{
    char idx;
    bool sep;
    YI():idx(-1),sep(true) {}
    char flood(YI&yi) {if (++idx<++yi.idx) idx=yi.idx; else yi.idx=idx; sep=yi.sep=true; return idx;}
    void operator++() {++idx;}
    operator char() const {return idx;}
  }li,ri;	// linker Achsenindex, rechter Achsenindex
  DWORD digiplotbits=0;
  char digiplots=0;	// = popcount(digiplotbits)
  for (iya=yaxes.begin(); iya!=yaxes.end(); iya++) {
    YAxis&ax=**iya;
    if (!ax.visible()) continue;	// Unsichtbare Achse auslassen
    YI&yi=ax.side&Axis::BOTTOMRIGHT?ri:li;
    if (ax.side&Axis::SEPARATE) {
      if (ax.side&Axis::DIGITAL) {
        li.flood(ri);	// beide 1 erhhen und gleichsetzen
        digiplotbits|=1<<li;
      }else{
        ++yi; yi.sep=true;	// rechten ODER linken Index erhhen
      }
    }else{
      if (yi.sep) ++yi;	// automatisch von -1 auf 0
      yi.sep=false;
    }
  ax.plotarea=yi;	// Plotarea-Index zuweisen
  }
  unsigned numplots=li.flood(ri);	// Anzahl Plots (0 wenn nichts dargestellt wird: Bld!!)
#endif
// Achtung: Digitalachsen sind links UND rechts! Wie umgehen damit? (Hier noch nicht. Ist 'ne Art Span)
// Vertikal: Divider prfen und ggf. erstellen
  int digiplots=0;	// Plots mit fester Hhe
//  int anaplots=0;	// Hhenskalierbare Plots
//  bool recalc=false;
#if 0
  for (ia=areas.begin(); ia!=areas.end(); ia++) {
    Plotarea&pa=**ia;
    if (!pa.visible) continue;
    if (!pa.valid) recalc=true;
    if (pa.fixedheight) digiplots++; else anaplots++;
  }
  if (recalc) {	// Anzahl (TODO: sichtbarer!!) Plotbereiche gendert: Divider neu erstellen
    int digiplot_h=32;	// TODO: Achse fragen!
    int anaplot_h=0;		// variabel
    if (anaplots) {
      h-=digiplot_h*digiplots;	// Fr Analogplots verbleibende Hhe
      anaplot_h=h/anaplots;	// Auf alle skalierbaren 
    }
    setMax(anaplot_h,digiplot_h);	// mindestens genausoviel spendieren
// vorwrts verteilen
    int y=0;
    for (ia=areas.begin(); ia!=areas.end(); ia++) {
      Plotarea&pa=**ia;
      if (!pa.visible) continue;
      y+=pa.fixedheight ? digiplot_h : anaplot_h;
      y+=pa.margin.top+pa.margin.bottom;	// Platz fr Achsen dazu
      pa.ydiv=y;
      pa.valid=true;		// Rechtecke stimmen noch nicht!!
    }
// es macht erst mal nichts, wenn sich durch Rundungseffekte ein paar Leerpixel am unteren Rand ergeben
  }
// Y-Achsen vermessen:
  int y=0;
  for (ia=yaxes.begin(); iya!=yaxes.end(); iya++) {
    YAxis&ax=**iya;
      if (!ax.visible()) continue;
      ax.rect.top=y;
      ax.rect.bottom=pa.ydiv;
      Margin m;
      ax.needSpace(m);	// TODO: Mindesthhe verarbeiten
      pa.margin.left+=m.left;
      pa.margin.right+=m.right;
      setMax(pa.margin.top,m.top);
      setMax(pa.margin.bottom,m.bottom);
    }
    setMax(spaceLeft,pa.margin.left);	// X-Achsen-berhang auf Platz fr Y-Achsen erweitern
    setMax(spaceRight,pa.margin.right);
    y=pa.ydiv;
  }
// Plotbereiche auf gleiche Breite bringen, Rechtecke berechnen, Achsen-Rechtecke setzen
  y=0;
  for (ia=areas.begin();ia!=areas.end();ia++) {
    Plotarea&pa=**ia;
    if (!pa.visible) continue;
    pa.margin.left=spaceLeft;
    pa.margin.right=spaceRight;
    pa.rect.left=rcClient.left+spaceLeft;
    pa.rect.right=rcClient.right-spaceRight;
    if (pa.rect.width()<32) pa.rect.right=pa.rect.left+32;	// Minimale, positive Breite garantieren; notfalls gibt's Scrollbars
    pa.rect.top=y+pa.margin.top;
    pa.rect.bottom=(y=pa.ydiv)-pa.margin.bottom;
    if (pa.rect.height()<8) pa.rect.bottom=pa.rect.top+8;	// drfte nicht passieren, wenn ydivs richtig verteilt wurden
    LONG l=pa.rect.top, r=pa.rect.bottom;
    for (ixa=pa.xaxes.begin(); ixa!=pa.xaxes.end(); ixa++) {
      XAxis&ax=**ixa;
      if (!ax.visible()) continue;
      ax.rect.left=pa.rect.left;
      ax.rect.right=pa.rect.right;
      Margin m;
      ax.needSpace(m);	// 2. Gang, jetzt liegt die Breite fest
      if (m.bottom) {
        ax.rect.top=r; r+=m.bottom; ax.rect.bottom=r;	// Achse unten fixieren
      }else{
        ax.rect.bottom=l; l-=m.top; ax.rect.top=l;	// Achse oben fixieren
      }
//      ax.updateScaling(false);	// Nur Skale setzen, aber evtl. Datenbereich erneut abrufen
    }
    l=pa.rect.left; r=pa.rect.right;
    for (iya=pa.yaxes.begin(); iya!=pa.yaxes.end(); iya++) {
      YAxis&ax=**iya;
      if (!ax.visible()) continue;
      ax.rect.top=pa.rect.top;
      ax.rect.bottom=pa.rect.bottom;
      Margin m;
      ax.needSpace(m);	// 2. Gang, jetzt liegt die Hhe fest
      if (m.right) {	// auch fr Digitalskale: Achse (und Achsenrechteck) stets rechts
        ax.rect.left=r; r+=m.right; ax.rect.right=r;	// Achse rechts fixieren
      }else{
        ax.rect.right=l; l-=m.left; ax.rect.left=l;	// Achse links fixieren
      }
//      ax.updateScaling(false);
    }
  }
#endif
  if (shrink_ms<100) shrink_ms=1000;
  if (!cBack) cBack = Color(250,250,250);
  if (!cArea) cArea = Color(245,245,245);
  if (!bBack) bBack=Brush::create(cBack.applyOn());
  if (!bArea) bArea=Brush::create(cArea.applyOn());
  extents_xy[0].setMin(needX);
  extents_xy[1].setMin(needY);
  Rect<>R(hPlot,true);	//::GetClientRect(), true als Dummy-Konstruktorparameter
  if (onSize(R.width(),R.height(),false)) {
    for (it=traces.begin(); it!=traces.end(); it++) {
      Trace&tr=**it;
      if (tr.xydata[0] && tr.xydata[1]) tr.flags|=1<<Trace::bNeedCalcPolys;
    }
    SetTimer(hPlot,66,shrink_ms,0);
  }
//  dirty=0;
#ifndef USE_ALLOCA
  delete[] needY;
  delete[] needX;
#endif
}

bool PlotXY::onSize(int w, int h,bool fromOutside) {
 bool changeX = extents_xy[0].set(w),
      changeY = extents_xy[1].set(h);		// variable Breiten anpassen
 if (changeX||changeY) {
  for (axes_t::iterator ia=axes.begin(); ia!=axes.end(); ia++) {
   Axis&ax=**ia;
   if (changeX && !(ax.side&1)
   ||  changeY &&   ax.side&1) ax.updateScaling(false); 
  }
  if (fromOutside && !(dirty&1<<bArrangeAll))
   dirty|=1<<bArrangeAll;	// Rekursion!?
   invalidate();		// (vorerst) alles neu zeichnen lassen
 }
 return changeX||changeY;
}

void PlotXY::invalidate() {
 InvalidateRect(hPlot,0,FALSE);
}

void PlotXY::invalidate(const gridrange_t&gr) {
 Rect<>r=extent(gr);
// if (gr.x==0 && gr.y==0) DEBUG(("invalidate(%d,%d,%d,%d) => %d,%d,%d,%d",
//  gr.x,gr.y,gr.colspan,gr.rowspan,
//  r.left,r.top,r.width(),r.height()));
 InvalidateRect(hPlot,r,FALSE);	// Es kommt zur Hlle nicht bei paint() an!!
}

void PlotXY::invalidate(char ix, char iy) {
 Rect<>r=extent(ix,iy);
 InvalidateRect(hPlot,r,FALSE);
}

void PlotXY::invalidate(const TRACEATTR&t) {
 invalidate(icr(t.iplotx),icr(t.iploty));
}

void PlotXY::invalidate(const AXISATTR&a) {
 if (a.iaxis==1) DEBUG(("Achse %d neu zu zeichnen, hat %u Ticks",a.iaxis,reinterpret_cast<const Axis&>(a).ticks.size()));
 char gr[4];
 gr[a.side&1  ] = icr(a.iplotxy)-1;
 gr[a.side&1^1] = irc(a);
 gr[a.side&1^2] = 3;
 gr[a.side&1^3] = 1;
 invalidate(*reinterpret_cast<gridrange_t*>(gr));
}
#if 0
void PlotXY::update(unsigned what) {
  dirty|=what;
/*
  if (gr) {
    if (what&2) {	// Mit diesem Bit wird das Update der Skalen rund um den Plot angestoen
      InvalidateRect(hPlot,extent(*gr),FALSE);	// Plotbereich inklusive Skalen
    }else InvalidateRect(hPlot,extent(*gr),FALSE);	// Nur Plotbereich
  }else invalidate();	// alles
*/
}
#endif
Axis::ticks_t::const_iterator PlotXY::findEditableLabel(gridpos_t gridpos, Point<>&pt) const{
  for (axes_t::const_iterator axi=axes.begin();axi!=axes.end();axi++) {
    Axis&ax=**axi;
    char cr0=icr(ax)-1;
    if (ax.side&1) {	// vertikale Achse
      if (irc(ax)!=gridpos.x) continue;	// muss in erster oder letzter Spalte zu suchen sein
      if (unsigned(gridpos.y-cr0)>=3) continue;	// Editfeld kann in den Zwickelfeldern sein
    }
    Axis::ticks_t::const_iterator r=ax.findEditableLabel(pt);
    if (r) return r;
  }
  return 0;
}

GridLayout::gridpos_t PlotXY::findArea(Point<>&pt) const{
// Mausposition in Client-Koordinaten!
  GridLayout::gridpos_t ret;
  for (size_t i=0; i<2; i++) {
    const ExtentList&el=extents_xy[i];
    ExtentList::Extents::const_iterator it=el.locatePos(((int*)&pt)[i]);
    ((char*)&ret)[i]=it?char(it-el.extents.begin()):-1;
  }
  return ret;
// Ergebnis: Mausposition in Koordinaten der Grid-Zelle
}
/*
bool PlotXY::isDividerVariable(int i) {
  if ((unsigned)i>=areas.size()) return false;
  if (i==int(areas.size())-1) {
    Rect rc(hPlot,true);
    if (areas[i]->ydiv==rc.height()) return false;	// Auf letztem Divider UND exakt Client-Hhe?
  }
  bool varBefore=false, varAfter=false;
  for (int ia=0; ia<int(areas.size()); ia++) {
    if (!areas[ia]->fixedheight) {
      if (i<=ia) varBefore=true; else varAfter=true;	// Variable Hhe davor / danach vermerken
    }
  }
  return varBefore && varAfter;
}
*/
PlotXY::traces_t::const_iterator PlotXY::findTrace(const Point<>&pt) const{
  mousetrack.distance=FINF;
  traces_t::const_iterator best=0;
  for (traces_t::const_iterator it=traces.begin(); it!=traces.end(); it++) {
    const Trace&tr=**it;
    if (!tr.visible()) continue;
    if (!tr.editable()) continue;
// Voraussetzung: Trace ist durchgerechnet; liegt als Polyline in Pixelkoordinaten vor
    for (Trace::lines_t::const_iterator il=tr.lines.begin(); il!=tr.lines.end(); il++) {
      const Trace::points_t&line=**il;
      for (int k=0; k<(int)line.size()-1; k++) {
        Float w,d=distance(&line[k],pt,w);
        if (!(mousetrack.distance<=d)) {
	  best=it;
          mousetrack.distance=d;
	  mousetrack.segment=k;	// ganzzahlig
	  mousetrack.where=w;
	}
      }
    }
  }
  if (best) {
    mousetrack.icurve=0;
    mousetrack.itrace=static_cast<char>(best-traces.begin());
    mousetrack.iplotx=(*best)->iplotx;
    mousetrack.iploty=(*best)->iploty;
  }
  return mousetrack.distance<=MOUSECAPTURE ? best:0;
}

Float PlotXY::distance(const Point<>line[2],const Point<>&pt,Float&where) {
  Float x=Float(line[1].x-line[0].x),
	y=Float(line[1].y-line[0].y),	// Linienlnge
        a=Float(pt.x-line[0].x),
	b=Float(pt.y-line[0].y);	// Abstand Maus zum Startpunkt
  Float l2=Float(x)*Float(x)+Float(y)*Float(y);	// Quadrat der Linienlnge
  if (l2) {
    Float sp=x*a+y*b;	// Skalarprodukt
    where=sp/l2;	// Lngsanteil
  }else where=0;	// Entartete Strecke
  if (where<=0) return Float(_hypot(Float(a),Float(b)));	// Euklidischer Abstand vom Startpunkt
  if (where>=1) return Float(_hypot(Float(a-x),Float(b-y)));	// Euklidischer Abstand vom Endpunkt
  Float vp=x*b-a*y;	// Vektorprodukt
  return Float(fabs(vp)/sqrt(l2));	// (vorzeichenloser) Abstand von der Geraden
}

// aus Funkuhr/Karte.c

/***************************
 * Rollbalken - h, Skalen *
 ***************************/
// Kopiert das Verhalten von SetScrollInfo(): verndert nPage und nPos: Nicht ganz!
// Sondern erlaubt nPage > nMax-nMin+1 (weie Fensterflchen);
// fr diesen Fall wird nPos derart begrenzt, dass die Bitmap beliebig im Fenster
// platziert wird, aber nicht herausfllt.
// In diesem Fall begrenzt SetScrollInfo(), und GetScrollPos() darf nicht benutzt werden.
// Scrollbalken verschwinden sowieso, so dass keine SB_THUMBTRACK-Nachricht kommt.
// Voraussetzung: nMin<=nMax!
// Liefert neues si->nPos
static int LimitScroll(SCROLLINFO&si) {
 if (si.nMin<=si.nMax) {
  int a=si.nMin;		// Anfang
  int e=si.nMax-si.nPage+1;	// Ende (bzw. Anfang fr d<si->nPage)
  int p=si.nPos;
  if (a>e) {
   a=e;
   e=si.nMin;			// tauschen
  }
  ensureMinMax(p,a,e);
  if (si.nPos!=p) DEBUG(("LimitScroll: alt=%d, neu=%d",si.nPos,p));
  si.nPos=p;
 }
 return si.nPos;
}


// Schiebe Skale um oder auf bestimmte Position
// Liefert tatschliche Verschiebedifferenz, fr ScrollWindow()
int PlotXY::GenShift(bool nBar, char kode, int dx) {
 SCROLLINFO *si=0/*=ScrollInfo+nBar*/;
 int d=si->nPos;
 switch (kode) {
  case SB_LINELEFT:
  case SB_LINERIGHT: {
   dx=8;
   if (GetKeyState(VK_SHIFT)<0) dx<<=2;
   if (kode==SB_LINELEFT) dx=-dx;
  }break;
  case SB_PAGELEFT: dx=si->nPage; break;
  case SB_PAGERIGHT: dx=-(int)si->nPage; break;
  case SB_THUMBTRACK:
  case SB_THUMBPOSITION: {	// kann nur vorkommen, wenn Rollbalken sichtbar
   si->fMask=SIF_TRACKPOS;	// Position (als 32-Bit-Wert) holen
   //GetScrollInfo(hMap,nBar,si);
   si->nPos=si->nTrackPos;	// dx sollte hier 0 sein!
  }break;
  case SB_LEFT: si->nPos=si->nMin; break;
  case SB_RIGHT: si->nPos=si->nMax; break;
 }
 si->nPos+=dx;
 LimitScroll(*si);
// if (kShow&4<<nBar) {
//  si->fMask=SIF_POS;	// reicht
//  SetScrollInfo(hMap,nBar,si,TRUE);
// }
 if (si->nPos!=d) DEBUG(("GenShift(%d,%d,%d): alt=%d, neu=%d\n",nBar,kode,dx,d,si->nPos));
 return d-si->nPos;
}

// Plotinhalt um <dx> und <dy> verschieben
// liefert <true> wenn tatschlich verschoben wurde
bool PlotXY::Scroll(int dx, int dy) {
 RECT ScrollRect;	// TODO: Vom HotTrace
 ScrollWindow(hPlot,dx,dy,&ScrollRect,NULL);
 if (dx||dy) {
  //InvalSymbChange(K,90);
  if (hMini) InvalidateRect(hMini,NULL,FALSE);
  if (!bFromMouse) MousePosChanged();
  return true;
 }
 return false;
}

void PlotXY::SetScale(char /*kode*/) {
#if 0
 if (kode>=0 && kode!=66) {
  char lineadd=GetKeyState(VK_SHIFT)<0?1:4;	// Kleine Schritte mit gedrckter Shift-Taste
//  kAutoScale=0;
  switch (kode) {
   case SB_LINELEFT: kScale-=lineadd; break;
   case SB_LINERIGHT: kScale+=lineadd; break;
   case SB_PAGELEFT: kScale-=16; break;
   case SB_PAGERIGHT: kScale+=16; break;
   case 100: kScale=0; break;			// 1:1
  }
  setMin(kScale,64);	// begrenzen auf 2^4  = 16fach
  setMax(kScale,-64);	// begrenzen auf 2^-4 = 1/16
  Scale.N=1<<((128-kScale)>>4);		// ein rationales Verhltnis draus machen
  Scale.Z=lrint(exp(kScale/(LOG2E*16))*K->Scale.N);
 }else{
  int nBar=SB_HORZ;	// 0
  if (kode==66) goto beide;	// in Fenster einpassen, aber nicht kAutoScale setzen
  kAutoScale=-kode;	// -1, -2 oder -3
  switch (kAutoScale&3) {
   case 3: beide: 		// dort, wo's passt!
   if ((double)MapExtentExt(K,SB_VERT)/ScrollRectExt(K,SB_VERT)
    < (double)MapExtentExt(K,SB_HORZ)/ScrollRectExt(K,SB_HORZ)) break;
   case 2: nBar=SB_VERT;
  }
  Scale.Z=ScrollRectExt(K,nBar);
  Scale.N=MapExtentExt(K,nBar);
  kScale=lrint(log((double)K->Scale.Z/K->Scale.N)*(LOG2E*16));	// kScale informativ mitfhren
 }
 kAutoScaleSet(kAutoScale,3,0);
 kVisChange(0);
 AdjustScrollRange();
 ShowMini();
 AdjustWindowSize();
 CalcRects();
 InvalSymbChange(-1);
 if (kShow&0x40) StatusScale(K);
#endif
}

// bewegliches l,r innerhalb L,R zwingen (dafr Verchiebung ermitteln)
bool PlotXY::moveinto(int l, int r, int L, int R, int&v) {
 if (r-l>R-L) return false;	// passt berhaupt nicht
 v=0;
 if ((L-=l)>0) v=L;		// positiv
 else if ((R-=r)<0) v=R;	// negativ
 return true;
}

// Ziehe Rechteck in Mitte; dabei rc in unverschobenen Client-Koordinaten und pt (Schwerpunkt) in Bitmap-Koordinaten
// Fr TAB = Durchschalten der Regionen sowie (TODO) Lnder-Auswahl
int PlotXY::MoveRectInto(const RECT *rc, const POINT *pt, bool nBar) const{
	RECT ScrollRect;
 int t;
 int l=(&rc->left)[nBar];
 int r=(&rc->right)[nBar];
 int L=(&ScrollRect.left)[nBar];
 int R=(&ScrollRect.right)[nBar];
 if (r-l > R-L) {	// passt nicht hinein
  int M=(L+R)>>1;
  int n=0/*=bp2cp(K,(&pt->x)[nBar],nBar)*/;
  return M-n;		// kann 0 sein
 }
 t=shift(nBar);
 l+=t;
 r+=t;
 if (l<L) return L-l;	// nach rechts
 if (r>R) return R-r;	// nach links
 return 0;
}

// Macht das Trace-Umfangsrechteck sichtbar, indem es in das Fenster gezogen wird.
// Passt es nicht hinein, wird am Schwerpunkt zentriert.
// Wenn's vollstndig sichtbar ist, tut diese Funktion nichts.
// Hier: Berechnung der notwendigen Scrolldistanz in Pixel
int PlotXY::MoveInto(int k, bool nBar) const{
 const Trace&tr=*traces[k];
 return MoveRectInto(tr.rcPoly(),tr.Centroid(),nBar);
}

void PlotXY::FocusTrace(int k) {
 HandleShift(MoveInto(k,SB_HORZ),MoveInto(k,SB_VERT));
 SetHoverIndex((char)k);	// es funktioniert nicht "smooth", wenn man die Reihenfolge vertauscht!!
}

// Die Tab-Taste setzt die Hover-Funktion der Maus temporr auer Kraft,
// und der numerisch nchste/vorhergehende Trace wird fokussiert
// Grobuchstabe (Shift gedrckt) = rckwrts, Kleinbuchstabe (Bit 5 gesetzt) vorwrts
void PlotXY::HandleTab(TCHAR suche) {
 char k=HoverIndex;
 char start=k;
 char e=char(traces.size());
 char dir=GetKeyState(VK_SHIFT)<0?-1:1;
 if (start<0) start=dir>=0?e-1:0;
 for(;;){
  k+=dir;
  if (k<0) k=e-1;
  if (k>=e) k=0;	// umlaufend
  if (k==start) {MessageBeep(MB_ICONSTOP); return;}
 }
 FocusTrace(k);
}
