#pragma once
//#define WINVER 0x0500
#ifndef _WIN32_WINNT
# define _WIN32_WINNT 0x0500
#endif
#include <windows.h>

#ifdef _M_IX86

#ifndef __field_ecount_opt
# define __field_ecount_opt(x)
#endif
#ifndef __out_ecount
# define __out_ecount(x)
#endif
#ifndef __out_bcount
# define __out_bcount(x)
#endif

#if _MSC_VER < 1900
__forceinline __int64 llrint(double f) {
 __int64 i;
 _asm	fld	f
 _asm	fistp	i
 return i;
}

__forceinline int lrint(float f) {
 int i;
 _asm	fld	f
 _asm	fistp	i
 return i;
}
#endif

#if _MSC_VER < 1400	// Visual C++ 6
#pragma warning(disable:4035)
__forceinline char _BitScanForward(DWORD*Index, DWORD v) {
 _asm	bsf	eax,v
 _asm	mov	ecx,Index	// ohne ECX einzusauen geht es hier nicht
 _asm	mov	[ecx],eax
 _asm	setnz	al
}
__forceinline char _BitScanReverse(DWORD*Index, DWORD v) {
 _asm	bsr	eax,v
 _asm	mov	ecx,Index
 _asm	mov	[ecx],eax
 _asm	setnz	al
}
__forceinline char _bittest(const void*p, DWORD bitnum) {
 _asm	mov	ecx,p
 _asm	mov	eax,bitnum
 _asm	bt	dword ptr [ecx],eax
 _asm	setc	al
}
__forceinline char _bittestandset(void*p, DWORD bitnum) {
 _asm	mov	ecx,p
 _asm	mov	eax,bitnum
 _asm	bts	dword ptr [ecx],eax
 _asm	setc	al
}
__forceinline char _bittestandreset(void*p, DWORD bitnum) {
 _asm	mov	ecx,p
 _asm	mov	eax,bitnum
 _asm	btr	dword ptr [ecx],eax
 _asm	setc	al
}
__forceinline char _bittestandcomplement(void*p, DWORD bitnum) {
 _asm	mov	ecx,p
 _asm	mov	eax,bitnum
 _asm	btc	dword ptr [ecx],eax
 _asm	setc	al
}
__forceinline void __stosb(BYTE*p, BYTE val, DWORD count) {
 _asm	mov	edi,p
 _asm	mov	al,val
 _asm	mov	ecx,count
 _asm	rep stosb
}
__forceinline void __stosw(WORD*p, WORD val, DWORD count) {
 _asm	mov	edi,p
 _asm	mov	ax,val
 _asm	mov	ecx,count
 _asm	rep stosw
}
__forceinline void __stosd(DWORD*p, DWORD val, DWORD count) {
 _asm	mov	edi,p
 _asm	mov	eax,val
 _asm	mov	ecx,count
 _asm	rep stosd
}
__forceinline void __movsb(BYTE*d, const BYTE*s, DWORD count) {
 _asm	mov	edi,d
 _asm	mov	esi,s
 _asm	mov	ecx,count
 _asm	rep movsb
}
__forceinline void __movsw(WORD*d, const WORD*s, DWORD count) {
 _asm	mov	edi,d
 _asm	mov	esi,s
 _asm	mov	ecx,count
 _asm	rep movsw
}
__forceinline void __movsd(DWORD*d, const DWORD*s, DWORD count) {
 _asm	mov	edi,d
 _asm	mov	esi,s
 _asm	mov	ecx,count
 _asm	rep movsd
}

// Naive Implementierung:
inline BYTE _fastcall __popcnt(unsigned v) {
 BYTE r=0;
 while (v) {r+=BYTE(v)&1; v>>=1;}
 return r;
}

inline BYTE _fastcall __popcnt16(unsigned short v) {return __popcnt(v);}

inline BYTE _fastcall __popcnt64(unsigned __int64 v) {
 BYTE r=0;
 while (v) {r+=BYTE(v)&1; v>>=1;}
 return r;
}

/* in assembly it can be a tight loop
	xor	eax,eax	// C = 0
1:	adc	al,0	// On entry, eax unchanged, otherwise increment when C set
	shr	rcx,1	// set C (the shift-out bit) and Z (ecx==0)
	jnz	1b	// continue or abort loop first, then use C
	adc	al,0	// on exit, add C (which ist mostly 1 = the MSB)
	ret

Byteweise-parallele Addition, da luft auch ohne SIMD nichts ber
	xor	rax,rax
	mov	rdx,rcx
	mov	ecx,8
1:	mov	r8,rdx
	and	r8,0x0101010101010101
	add	rax,r8	// rax += rdx & mask
	shr	rdx,1	// Nchste Bits in Position bringen
	loop	1b	// 8 Runden
// Jetzt enthlt rax in jedem der 8 Byte den Popcount jedes der 8 Bytes von rcx.
// Maximal 8. Zusammenzhlen, ebenfalls parallel
	mov	rdx,rax
	shr	rdx,32
	add	eax,edx	// 4 Bytes
	mov	edx,eax
	shr	edx,16
	add	eax,edx	// 2 Bytes
	add	al,ah	// 1 Byte
	and	eax,0x7F	// da kann maximal 64 'rauskommen
	ret
 */

#pragma warning(default:4035)
#else
# include <intrin.h>
#endif
#else 
# include <intrin.h>
#endif

#if _MSC_VER < 1900	// lrint(), llrint() bei Visual C++ 2019 bereits definiert
# ifdef _M_IX86
inline int lrint(double x) {return (int)llrint(x);}
# else
inline __int64 llrint(double x) {return _mm_cvtsd_si64(*(__m128d*)&x);}
inline int lrint(double x) {return _mm_cvtsd_si32(*(__m128d*)&x);}
# endif
#endif

#ifndef GetWindowLongPtr
# define GetWindowLongPtr GetWindowLong
# define SetWindowLongPtr SetWindowLong
# define ULONG_PTR DWORD
#endif
#ifndef elemof
# define elemof(x) (sizeof(x)/sizeof((x)[0]))
#endif

